/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.19 Revision 1.68
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.19 2009/05/14 16:46:53 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.68 2012/09/04 14:08:24 johu Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14 14
15[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
16
15inherit kde4-base versionator 17inherit kde4-base versionator
16 18
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 19KDEMETA_EXPF="pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm"
18 20EXPORT_FUNCTIONS ${KDEMETA_EXPF}
19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi
22
23case ${KDEBASE} in
24 kde-base)
25 HOMEPAGE="http://www.kde.org/"
26 LICENSE="GPL-2"
27 ;;
28 koffice)
29 HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2"
31 ;;
32esac
33
34# Add khelpcenter dependency when installing
35if [[ ${PN} != khelpcenter ]] && has doc ${IUSE//+} && use doc; then
36 RDEPEND="${RDEPEND}
37 >=kde-base/khelpcenter-${PV}:${SLOT}[kdeprefix=]
38 "
39fi
40 21
41# Add dependencies that all packages in a certain module share. 22# Add dependencies that all packages in a certain module share.
42case ${KMNAME} in 23case ${KMNAME} in
43 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphic) 24 kdebase|kdebase-apps|kde-baseapps|kdebase-workspace|kde-workspace|kdebase-runtime|kde-runtime|kdegraphics)
44 DEPEND="${DEPEND} 25 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
45 >=kde-base/qimageblitz-0.0.4
46 "
47 RDEPEND="${RDEPEND}
48 >=kde-base/qimageblitz-0.0.4
49 "
50 ;; 26 ;;
51 kdenetwork) 27 kdepim|kdepim-runtime)
52 DEPEND="${DEPEND}
53 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
54 "
55 RDEPEND="${RDEPEND}
56 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
57 "
58 ;;
59 kdepim)
60 DEPEND="${DEPEND}
61 dev-libs/boost
62 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
63 "
64 RDEPEND="${RDEPEND}
65 dev-libs/boost
66 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
67 "
68 case ${PN} in 28 case ${PN} in
69 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 29 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
70 IUSE="+kontact" 30 IUSE+=" +kontact"
71 RDEPEND="${RDEPEND} 31 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
72 kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )
73 "
74 ;; 32 ;;
75 esac 33 esac
76 ;; 34 ;;
77 kdegames) 35 kdegames)
78 if [[ ${PN} != libkdegames ]]; then 36 if [[ ${PN} != libkdegames ]]; then
79 DEPEND="${DEPEND} 37 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
80 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
81 "
82 RDEPEND="${RDEPEND}
83 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
84 "
85 fi
86 ;;
87 koffice)
88 [[ ${PN} != koffice-data ]] && IUSE="debug"
89 RDEPEND="${RDEPEND}
90 !app-office/${PN}:0
91 !app-office/koffice:0
92 !app-office/koffice-meta:0
93 "
94 COMMON_DEPEND="
95 dev-cpp/eigen:2
96 media-gfx/imagemagick[openexr?]
97 media-libs/fontconfig
98 media-libs/freetype:2
99 "
100 DEPEND="${DEPEND} ${COMMON_DEPEND}"
101 RDEPEND="${RDEPEND} ${COMMON_DEPEND}"
102 unset COMMON_DEPEND
103 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
104 DEPEND="${DEPEND}
105 >=app-office/koffice-libs-${PV}:${SLOT}
106 "
107 RDEPEND="${RDEPEND}
108 >=app-office/koffice-libs-${PV}:${SLOT}
109 "
110 fi 38 fi
111 ;; 39 ;;
112esac 40esac
113 41
42DEPEND+=" ${COMMONDEPEND}"
43RDEPEND+=" ${COMMONDEPEND}"
44unset COMMONDEPEND
45
114debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 46debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
115debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 47debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
116 48
117# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 49# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
118case ${BUILD_TYPE} in 50case ${KDE_BUILD_TYPE} in
119 live) 51 live)
52 if [[ ${KDE_SCM} == svn ]]; then
120 case ${KMNAME} in 53 case ${KMNAME} in
121 extragear*|playground*) 54 extragear*|playground*)
122 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}" 55 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
123 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}" 56 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
124 ;; 57 ;;
125 esac 58 esac
59 fi
126 ;; 60 ;;
127esac 61esac
128 62
129# @ECLASS-VARIABLE: KMNAME 63# @ECLASS-VARIABLE: KMNAME
130# @DESCRIPTION: 64# @DESCRIPTION:
145# If set to "true", $KMMODULE doesn't have to be defined. 79# If set to "true", $KMMODULE doesn't have to be defined.
146# 80#
147# Example usage: If you're installing subdirectories of a package, like plugins, 81# Example usage: If you're installing subdirectories of a package, like plugins,
148# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and 82# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
149# set KMNOMODULE="true". 83# set KMNOMODULE="true".
150if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then 84if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
151 KMMODULE=${PN} 85 KMMODULE=${PN}
152fi 86fi
153 87
154# @ECLASS-VARIABLE: KMEXTRA 88# @ECLASS-VARIABLE: KMEXTRA
155# @DESCRIPTION: 89# @DESCRIPTION:
156# All subdirectories listed here will be extracted, compiled & installed. 90# All subdirectories listed here will be extracted, compiled & installed.
157# $KMMODULE is always added to $KMEXTRA. 91# $KMMODULE is always added to $KMEXTRA.
158# If the htmlhandbook USE-flag is set, and if this directory exists, 92# If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
159# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 93# directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
160# handled in the ebuild.
161# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 94# documentation in different subdirectories, it should be added to KMEXTRA manually..
162 95
163# @ECLASS-VARIABLE: KMCOMPILEONLY 96# @ECLASS-VARIABLE: KMCOMPILEONLY
164# @DESCRIPTION: 97# @DESCRIPTION:
165# All subdirectories listed here will be extracted & compiled, but not installed. 98# All subdirectories listed here will be extracted & compiled, but not installed.
166 99
175# Specify extra parameters to pass to tar, in kde4-meta_src_extract. 108# Specify extra parameters to pass to tar, in kde4-meta_src_extract.
176# '-xpf -j' are passed to tar by default. 109# '-xpf -j' are passed to tar by default.
177 110
178# @FUNCTION: kde4-meta_pkg_setup 111# @FUNCTION: kde4-meta_pkg_setup
179# @DESCRIPTION: 112# @DESCRIPTION:
180# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in 113# Currently calls its equivalent in kde4-base.eclass(5) and checks the gcc version.
181# split ebuilds. 114# Use this one in split ebuilds.
182kde4-meta_pkg_setup() { 115kde4-meta_pkg_setup() {
183 debug-print-function ${FUNCNAME} "$@" 116 debug-print-function ${FUNCNAME} "$@"
184 117
185 kde4-base_pkg_setup 118 kde4-base_pkg_setup
186} 119}
187 120
188# @FUNCTION: kde4-meta_src_unpack 121# @FUNCTION: kde4-meta_src_unpack
189# @DESCRIPTION: 122# @DESCRIPTION:
190# This function unpacks the source for split ebuilds. See also 123# This function unpacks the source for split ebuilds.
191# kde4-meta-src_extract. 124# Further more is processed in kde4-meta_src_extract
192kde4-meta_src_unpack() { 125kde4-meta_src_unpack() {
193 debug-print-function ${FUNCNAME} "$@" 126 debug-print-function ${FUNCNAME} "$@"
194 127
195 if [[ ${BUILD_TYPE} = live ]]; then 128 if [[ ${KDE_BUILD_TYPE} = live ]]; then
129 case "${KDE_SCM}" in
130 svn)
196 migrate_store_dir 131 migrate_store_dir
197 S="${WORKDIR}/${P}" 132 S="${WORKDIR}/${P}"
198 mkdir -p "${S}" 133 mkdir -p "${S}"
199 ESVN_RESTRICT="export" subversion_src_unpack 134 ESVN_RESTRICT="export" subversion_src_unpack
200 subversion_wc_info 135 subversion_wc_info
201 subversion_bootstrap 136 subversion_bootstrap
137 ;;
138 git)
139 git-2_src_unpack
140 ;;
141 esac
142 fi
202 kde4-meta_src_extract 143 kde4-meta_src_extract
203 else
204 kde4-meta_src_extract
205 fi
206} 144}
207
208# FIXME: the difference between kde4-meta_src_extract and kde4-meta_src_unpack?
209 145
210# @FUNCTION: kde4-meta_src_extract 146# @FUNCTION: kde4-meta_src_extract
211# @DESCRIPTION: 147# @DESCRIPTION:
212# A function to unpack the source for a split KDE ebuild. 148# A function to extract the source for a split KDE ebuild.
213# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and 149# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
214# KMTARPARAMS. 150# KMTARPARAMS.
215kde4-meta_src_extract() { 151kde4-meta_src_extract() {
216 debug-print-function ${FUNCNAME} "$@" 152 debug-print-function ${FUNCNAME} "$@"
217 153
218 if [[ ${BUILD_TYPE} = live ]]; then 154 if [[ ${KDE_BUILD_TYPE} = live ]]; then
219 local rsync_options subdir kmnamedir targetdir
220 # Export working copy to ${S} 155 # Export working copy to ${S}
221 einfo "Exporting parts of working copy to ${S}" 156 einfo "Exporting parts of working copy to ${S}"
222 kde4-meta_create_extractlists 157 kde4-meta_create_extractlists
223 158
159 case ${KDE_SCM} in
160 svn)
161 local rsync_options subdir targetdir wc_path escm
162
224 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/" 163 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/ --exclude=.git/"
164 wc_path="${ESVN_WC_PATH}"
165 escm="{ESVN}"
225 166
226 # Copy ${KMNAME} non-recursively (toplevel files) 167 # Copy ${KMNAME} non-recursively (toplevel files)
227 rsync ${rsync_options} "${ESVN_WC_PATH}"/${kmnamedir}* "${S}" \ 168 rsync ${rsync_options} "${wc_path}"/* "${S}" \
228 || die "${ESVN}: can't export toplevel files to '${S}'." 169 || die "${escm}: can't export toplevel files to '${S}'."
229 # Copy cmake directory 170 # Copy cmake directory
230 if [[ -d "${ESVN_WC_PATH}/${kmnamedir}cmake" ]]; then 171 if [[ -d "${wc_path}/cmake" ]]; then
231 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \ 172 rsync --recursive ${rsync_options} "${wc_path}/cmake" "${S}" \
232 || die "${ESVN}: can't export cmake files to '${S}'." 173 || die "${escm}: can't export cmake files to '${S}'."
233 fi 174 fi
234 # Copy all subdirectories 175 # Copy all subdirectories
235 for subdir in $(__list_needed_subdirectories); do 176 for subdir in $(__list_needed_subdirectories); do
236 targetdir="" 177 targetdir=""
237 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then 178 if [[ $subdir = doc/* && ! -e "$wc_path/$subdir" ]]; then
238 continue 179 continue
239 fi 180 fi
240 181
241 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}" 182 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
242 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \ 183 rsync --recursive ${rsync_options} "${wc_path}/${subdir%/}" "${S}/${targetdir}" \
243 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'." 184 || die "${escm}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
244 done 185 done
245
246 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then
247 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
248 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
249 fi
250 else
251 local abort tarball tarfile f extractlist moduleprefix postfix
252 case ${PV} in
253 4.2.85)
254 # block for normally packed upstream unstable snapshots
255 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2
256 postfix="bz2"
257 ;;
258 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*)
259 KMTARPARAMS="${KMTARPARAMS} --lzma" # lzma
260 postfix="lzma"
261 ;;
262 *)
263 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2
264 postfix="bz2"
265 ;; 186 ;;
266 esac 187 esac
188 else
189 local abort tarball tarfile f extractlist postfix
190
191 if [[ ${PV} =~ 4.[47].[12345] ]]; then
192 postfix="bz2"
193 KMTARPARAMS+=" --bzip2"
194 else
195 postfix="xz"
196 KMTARPARAMS+=" --xz"
197 fi
198
267 case ${KMNAME} in 199 case ${KMNAME} in
268 kdebase-apps) 200 kdebase-apps)
269 # kdebase/apps -> kdebasa-apps 201 # kdebase/apps -> kdebase-apps
270 tarball="kdebase-${PV}.tar.${postfix}" 202 tarball="kdebase-${PV}.tar.${postfix}"
271 # Go one level deeper for kdebase-apps in tarballs
272 moduleprefix=apps/
273 KMTARPARAMS="${KMTARPARAMS} --transform=s|apps/||"
274 ;; 203 ;;
275 *) 204 *)
276 # Create tarball name from module name (this is the default) 205 # Create tarball name from module name (this is the default)
277 tarball="${KMNAME}-${PV}.tar.${postfix}" 206 tarball="${KMNAME}-${PV}.tar.${postfix}"
278 ;; 207 ;;
279 esac 208 esac
280 209
281 # Full patch to source tarball 210 # Full path to source tarball
282 tarfile="${DISTDIR}/${tarball}" 211 tarfile="${DISTDIR}/${tarball}"
283 212
284 # Detect real toplevel dir from tarball name - it will be used upon extraction 213 # Detect real toplevel dir from tarball name - it will be used upon extraction
285 # and in __list_needed_subdirectories 214 # and in __list_needed_subdirectories
286 topdir="${tarball%.tar.*}/" 215 topdir="${tarball%.tar.*}/"
287 216
288 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}" 217 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
289 218
290 kde4-meta_create_extractlists 219 kde4-meta_create_extractlists
291 220
292 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 221 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake
293 AUTHORS COPYING INSTALL README NEWS ChangeLog
294 do 222 do
295 extractlist="${extractlist} ${topdir}${moduleprefix}${f}" 223 extractlist+=" ${topdir}${f}"
296 done 224 done
297 extractlist="${extractlist} $(__list_needed_subdirectories)" 225 extractlist+=" $(__list_needed_subdirectories)"
298 226
299 pushd "${WORKDIR}" > /dev/null 227 pushd "${WORKDIR}" > /dev/null
228
229 # @ECLASS-VARIABLE: KDE4_STRICTER
230 # @DESCRIPTION:
231 # Print out all issues found executing tar / kmextract files
232 # Set on if you want to find issues in kde-base ebuild unpack sequences
300 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 233 [[ -n ${KDE4_STRICTER} ]] && echo 'tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}'
301 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 234 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null || echo "tar extract command failed at least partially - continuing anyway"
302 235
303 # Default $S is based on $P; rename the extracted directory to match $S if necessary 236 # Default $S is based on $P; rename the extracted directory to match $S if necessary
237 if [[ ${KMNAME} != ${PN} ]]; then
304 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\"" 238 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
239 fi
305 240
306 popd > /dev/null 241 popd > /dev/null
307 242
308 eend $? 243 eend $?
309
310 # We need to clear it here to make verification below work
311 unset moduleprefix
312 244
313 if [[ -n ${KDE4_STRICTER} ]]; then 245 if [[ -n ${KDE4_STRICTER} ]]; then
314 for f in $(__list_needed_subdirectories fatal); do 246 for f in $(__list_needed_subdirectories fatal); do
315 if [[ ! -e "${S}/${f#*/}" ]]; then 247 if [[ ! -e ${S}/${f#*/} ]]; then
316 eerror "'${f#*/}' is missing" 248 eerror "'${f#*/}' is missing"
317 abort=true 249 abort=true
318 fi 250 fi
319 done 251 done
320 [[ -n ${abort} ]] && die "There were missing files." 252 [[ -n ${abort} ]] && die "There were missing files."
331# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 263# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
332# KMEXTRACTONLY and KMTARPARAMS. 264# KMEXTRACTONLY and KMTARPARAMS.
333kde4-meta_create_extractlists() { 265kde4-meta_create_extractlists() {
334 debug-print-function ${FUNCNAME} "$@" 266 debug-print-function ${FUNCNAME} "$@"
335 267
336 # TODO change to KMEXTRA for more strict check 268 # Add default handbook locations
337 if has doc ${IUSE//+} && use doc && [[ -n ${KMMODULE} ]]; then 269 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
270 if [[ $(get_kde_version) < 4.5 ]] && use_if_iuse handbook && [[ -z ${KMNOMODULE} ]]; then
338 # We use the basename of $KMMODULE because $KMMODULE can contain 271 # We use the basename of $KMMODULE because $KMMODULE can contain
339 # the path to the module subdirectory. 272 # the path to the module subdirectory.
273 KMEXTRA_NONFATAL+="
274 doc/${KMMODULE##*/}"
275 fi
276
277 # Add default handbook locations
278 if [[ -z ${KMNOMODULE} ]] && ( [[ ${KDE_HANDBOOK} == always ]] || ( [[ ${KDE_HANDBOOK} == optional ]] && use handbook ) ); then
340 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 279 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
341 fi 280 fi
342 281
343 # Add some CMake-files to KMEXTRACTONLY. 282 # Add some CMake-files to KMEXTRACTONLY.
344 # Note that this actually doesn't include KMEXTRA handling. 283 # Note that this actually doesn't include KMEXTRA handling.
345 # In those cases you should care to add the relevant files to KMEXTRACTONLY 284 # In those cases you should care to add the relevant files to KMEXTRACTONLY
346 case ${KMNAME} in 285 case ${KMNAME} in
347 kdebase) 286 kdebase | kdebase-apps | kde-baseapps)
348 KMEXTRACTONLY="${KMEXTRACTONLY} 287 KMEXTRACTONLY+="
349 apps/config-apps.h.cmake
350 apps/ConfigureChecks.cmake"
351 ;;
352 kdebase-apps)
353 KMEXTRACTONLY="${KMEXTRACTONLY}
354 config-apps.h.cmake 288 config-apps.h.cmake
355 ConfigureChecks.cmake" 289 ConfigureChecks.cmake"
356 ;; 290 ;;
357 kdebase-runtime) 291 kdebase-runtime | kde-runtime)
358 KMEXTRACTONLY="${KMEXTRACTONLY} 292 KMEXTRACTONLY+="
293 CTestConfig.cmake
359 config-runtime.h.cmake" 294 config-runtime.h.cmake"
360 ;; 295 ;;
361 kdebase-workspace) 296 kdebase-workspace | kde-workspace)
362 KMEXTRACTONLY="${KMEXTRACTONLY} 297 KMEXTRACTONLY+="
363 config-unix.h.cmake 298 config-unix.h.cmake
364 ConfigureChecks.cmake 299 ConfigureChecks.cmake
365 config-workspace.h.cmake 300 config-workspace.h.cmake
366 config-X11.h.cmake 301 config-X11.h.cmake
367 startkde.cmake 302 startkde.cmake
368 KDE4WorkspaceConfig.cmake.in" 303 KDE4WorkspaceConfig.cmake.in"
369 ;; 304 ;;
370 kdegames) 305 kdegames)
371 if [[ ${PN} != libkdegames ]]; then 306 if [[ ${PN} != libkdegames ]]; then
372 KMEXTRACTONLY="${KMEXTRACTONLY} 307 KMEXTRACTONLY+="
373 libkdegames" 308 libkdegames/"
309 KMLOADLIBS="${KMLOADLIBS} libkdegames"
374 fi 310 fi
375 ;; 311 ;;
376 kdepim) 312 kdepim)
377 if [[ ${PN} != libkdepim ]]; then 313 if [[ ${PN} != libkdepim ]]; then
378 KMEXTRACTONLY="${KMEXTRACTONLY} 314 KMEXTRACTONLY+="
379 libkdepim" 315 libkdepim/"
380 fi 316 fi
381 case ${SLOT} in 317 KMEXTRACTONLY+="
382 4.3|live)
383 KMEXTRACTONLY="${KMEXTRACTONLY}
384 kdepim-version.h
385 config-enterprise.h.cmake" 318 config-enterprise.h.cmake
386 ;;
387 esac
388 KMEXTRACTONLY="${KMEXTRACTONLY}
389 kleopatra/ConfigureChecks.cmake" 319 kleopatra/ConfigureChecks.cmake"
390 if has kontact ${IUSE//+} && use kontact; then 320 if ! [[ $(get_kde_version) < 4.5 ]]; then
321 KMEXTRACTONLY+="
322 CTestCustom.cmake
323 kdepim-version.h.cmake"
324 else
325 KMEXTRACTONLY+="
326 kdepim-version.h"
327 fi
328 if use_if_iuse kontact; then
329 KMEXTRA+="
391 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 330 kontact/plugins/${PLUGINNAME:-${PN}}/"
392 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/"
393 fi 331 fi
394 ;; 332 ;;
395 koffice) 333 kdeutils)
396 KMEXTRACTONLY="${KMEXTRACTONLY} 334 KMEXTRACTONLY+="
397 config-endian.h.cmake 335 kdeutils-version.h"
398 filters/config-filters.h.cmake
399 config-openctl.h.cmake
400 config-openexr.h.cmake
401 config-opengl.h.cmake
402 config-prefix.h.cmake"
403 ;; 336 ;;
404 esac 337 esac
405 # Don't install cmake modules for split ebuilds, to avoid collisions. 338 # Don't install cmake modules for split ebuilds, to avoid collisions.
339 # note: kdegraphics >= 4.6.2 does not even have code to do that, so we
340 # should not try in that case
341 # note2: kdeedu 4.6.4 does not have a cmake/modules/ subdir anymore :(
342 # it may be possible to formulate this shorter, but it should also
343 # still be understandable...
344 if [[ ${KMNAME} != kdegraphics || ( ( $(get_kde_version) != 4.6 || ${PV} < 4.6.2 ) && $(get_kde_version) < 4.7 ) ]] \
345 && ! [[ ${KMNAME} == kdeedu && ( ${PV} == 4.6.4 || ${PV} == 4.6.5 ) ]] \
346 && ! [[ ${KMNAME} == kdegames && ${PV} > 4.9.0 ]]; then
406 case ${KMNAME} in 347 case ${KMNAME} in
407 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim) 348 kdebase-runtime|kde-runtime|kdebase-workspace|kde-workspace|kdeedu|kdegames|kdegraphics)
408 case ${PN} in 349 KMEXTRACTONLY+="
409 libkdegames|libkdeedu|libkworkspace)
410 KMEXTRA="${KMEXTRA}
411 cmake/modules/" 350 cmake/modules/"
412 ;; 351 ;;
413 *)
414 KMCOMPILEONLY="${KMCOMPILEONLY}
415 cmake/modules/"
416 ;;
417 esac 352 esac
418 ;; 353 fi
419 esac
420 354
421 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 355 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
422} 356}
423 357
424__list_needed_subdirectories() { 358__list_needed_subdirectories() {
425 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist 359 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
426 360
427 # We expand KMEXTRA by adding CMakeLists.txt files 361 # We expand KMEXTRA by adding CMakeLists.txt files
428 kmextra="${KMEXTRA}" 362 kmextra="${KMEXTRA}"
429 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 363 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
430 for i in ${kmextra}; do 364 for i in ${kmextra}; do
431 kmextra_expanded="${kmextra_expanded} ${i}" 365 kmextra_expanded+=" ${i}"
432 j=$(dirname ${i}) 366 j=$(dirname ${i})
433 while [[ ${j} != "." ]]; do 367 while [[ ${j} != "." ]]; do
434 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 368 kmextra_expanded+=" ${j}/CMakeLists.txt";
435 j=$(dirname ${j}) 369 j=$(dirname ${j})
436 done 370 done
437 done 371 done
438 372
439 # Expand KMMODULE 373 # Expand KMMODULE
440 if [[ -n ${KMMODULE} ]]; then 374 if [[ -n ${KMMODULE} ]]; then
441 kmmodule_expanded="${KMMODULE}" 375 kmmodule_expanded="${KMMODULE}"
442 j=$(dirname ${KMMODULE}) 376 j=$(dirname ${KMMODULE})
443 while [[ ${j} != "." ]]; do 377 while [[ ${j} != "." ]]; do
444 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt"; 378 kmmodule_expanded+=" ${j}/CMakeLists.txt";
445 j=$(dirname ${j}) 379 j=$(dirname ${j})
446 done 380 done
447 fi 381 fi
448 382
449 # Expand KMCOMPILEONLY 383 # Expand KMCOMPILEONLY
450 for i in ${KMCOMPILEONLY}; do 384 for i in ${KMCOMPILEONLY}; do
451 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 385 kmcompileonly_expanded+=" ${i}"
452 j=$(dirname ${i}) 386 j=$(dirname ${i})
453 while [[ ${j} != "." ]]; do 387 while [[ ${j} != "." ]]; do
454 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 388 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
455 j=$(dirname ${j}) 389 j=$(dirname ${j})
456 done 390 done
457 done 391 done
458 392
459 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 393 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
463 # Create final list of stuff to extract 397 # Create final list of stuff to extract
464 # We append topdir only when specified (usually for tarballs) 398 # We append topdir only when specified (usually for tarballs)
465 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 399 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
466 ${KMEXTRACTONLY} 400 ${KMEXTRACTONLY}
467 do 401 do
468 extractlist="${extractlist} ${topdir}${moduleprefix}${i}" 402 extractlist+=" ${topdir}${i}"
469 done 403 done
470 404
471 echo ${extractlist} 405 echo ${extractlist}
472} 406}
473 407
479 413
480 kde4-meta_change_cmakelists 414 kde4-meta_change_cmakelists
481 kde4-base_src_prepare 415 kde4-base_src_prepare
482} 416}
483 417
484# FIXME: no comment here? 418# @FUNCTION: _change_cmakelists_parent_dirs
419# @DESCRIPTION:
420# Adjust CMakeLists.txt to shadow subdirectories
421# that are not required for the build.
485_change_cmakelists_parent_dirs() { 422_change_cmakelists_parent_dirs() {
486 debug-print-function ${FUNCNAME} "$@" 423 debug-print-function ${FUNCNAME} "$@"
487 424
488 local _olddir _dir 425 local _olddir _dir
489 _dir="${S}"/${1} 426 _dir="${S}"/${1}
490 until [[ ${_dir} == "${S}" ]]; do 427 until [[ ${_dir} == ${S} ]]; do
491 _olddir=$(basename "${_dir}") 428 _olddir=$(basename "${_dir}")
492 _dir=$(dirname "${_dir}") 429 _dir=$(dirname "${_dir}")
493 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}" 430 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
494 if [[ -f ${_dir}/CMakeLists.txt ]]; then 431 if [[ -f ${_dir}/CMakeLists.txt ]]; then
495 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \ 432 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
497 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 434 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
498 fi 435 fi
499 done 436 done
500} 437}
501 438
502# FIXME: add description
503# @FUNCTION: kde4-meta_change_cmakelists 439# @FUNCTION: kde4-meta_change_cmakelists
504# @DESCRIPTION: 440# @DESCRIPTION:
441# Adjust CMakeLists.txt to comply to our splitting.
505kde4-meta_change_cmakelists() { 442kde4-meta_change_cmakelists() {
506 debug-print-function ${FUNCNAME} "$@" 443 debug-print-function ${FUNCNAME} "$@"
507 444
508 pushd "${S}" > /dev/null 445 pushd "${S}" > /dev/null
509 446
510 comment_all_add_subdirectory ./ 447 comment_all_add_subdirectory ./
511 448
512 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 449 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
513 if [[ -f "${S}"/CMakeLists.txt ]]; then 450 if [[ -f CMakeLists.txt ]]; then
514 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 451 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
515 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 452 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
516 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 453 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
454 fi
455
456 # Restore "add_subdirectory( ${ ..." (this is done in kdesdk)
457 if [[ -f CMakeLists.txt ]]; then
458 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*\${/s/^#DONOTCOMPILE //' \
459 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*\${/s/^#DONOTCOMPILE //' \
460 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
517 fi 461 fi
518 462
519 if [[ -z ${KMNOMODULE} ]]; then 463 if [[ -z ${KMNOMODULE} ]]; then
520 # Restore "add_subdirectory" in $KMMODULE subdirectories 464 # Restore "add_subdirectory" in $KMMODULE subdirectories
521 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 465 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
466 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
522 die "${LINENO}: died in KMMODULE section" 467 die "${LINENO}: died in KMMODULE section"
523 _change_cmakelists_parent_dirs ${KMMODULE} 468 _change_cmakelists_parent_dirs ${KMMODULE}
524 fi 469 fi
525 470
526 local i 471 local i
527 472
528 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY 473 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
529 for i in ${KMEXTRACTONLY}; do 474 for i in ${KMEXTRACTONLY}; do
530 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then 475 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
531 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \ 476 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
477 -i ${i}/../CMakeLists.txt || \
532 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}" 478 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
533 fi 479 fi
534 done 480 done
535 481
536 # KMCOMPILEONLY 482 # KMCOMPILEONLY
558 # KMEXTRA_NONFATAL section 504 # KMEXTRA_NONFATAL section
559 for i in ${KMEXTRA_NONFATAL}; do 505 for i in ${KMEXTRA_NONFATAL}; do
560 if [[ -d "${S}"/${i} ]]; then 506 if [[ -d "${S}"/${i} ]]; then
561 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 507 find "${S}"/${i} -name CMakeLists.txt -print0 | \
562 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 508 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
563 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 509 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
564 _change_cmakelists_parent_dirs ${i} 510 _change_cmakelists_parent_dirs ${i}
565 fi 511 fi
566 done 512 done
567 513
568 case ${KMNAME} in 514 case ${KMNAME} in
569 kdebase-workspace) 515 kdebase-workspace | kde-workspace)
570 # COLLISION PROTECT section 516 # COLLISION PROTECT section
571 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 517 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
572 # not as a part of every package. 518 # not as a part of every package.
573 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 519 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
574 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 520 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
575 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 521 sed -e '/startkde/s/^/#DONOTINSTALL /' \
576 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 522 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
577 fi 523 fi
524 # Remove workspace target prefix in order to get direct linking to workspace libs
525 sed -e '/set(KDE4WORKSPACE_TARGET_PREFIX/s/^/#OVERRIDE /' \
526 -i CMakeLists.txt || die "${LINENO}: sed died in KDE4WORKSPACE_TARGET_PREFIX removal section"
578 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 527 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
579 if [[ ${PN} != libkworkspace ]]; then 528 if [[ ${PN} != libkworkspace ]]; then
580 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 529 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
581 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section" 530 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace strip config install and fix EXPORT section"
582 fi 531 fi
532 if [[ ${PN} != plasma-workspace ]]; then
533 sed -e '/KActivities/s/REQUIRED//' \
534 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace dep reduction section"
535 fi
536 if [[ "${PN}" != "kwin" ]]; then
537 sed -i -e "/^ macro_log_feature(OPENGL_OR_ES_FOUND/s/TRUE/FALSE/" \
538 "${S}"/CMakeLists.txt || die "${LINENO}: sed died removing kde-workspace opengl dependency"
539 fi
583 ;; 540 ;;
584 kdebase-runtime) 541 kdebase-runtime | kde-runtime)
585 # COLLISION PROTECT section 542 # COLLISION PROTECT section
586 # Only install the kde4 script as part of kde-base/kdebase-data 543 # Only install the kde4 script as part of kde-base/kdebase-data
587 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 544 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
588 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 545 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
589 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 546 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
590 fi 547 fi
591 ;;
592 kdepim)
593 case ${PN} in
594 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn)
595 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
596 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed"
597 _change_cmakelists_parent_dirs kmail
598 ;; 548 ;;
599 esac 549 kdenetwork)
600 ;;
601 kdewebdev)
602 # Disable hardcoded kdepimlibs check 550 # Disable hardcoded kdepimlibs check
603 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \ 551 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
604 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2 REQUIRED)/' \
605 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt REQUIRED)/' \
606 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost REQUIRED)/' \
607 -i CMakeLists.txt || die "failed to disable hardcoded checks" 552 -i CMakeLists.txt || die "failed to disable hardcoded checks"
608 ;; 553 ;;
609 koffice) 554 kdepim)
610 # prevent collisions 555 # Disable hardcoded checks
611 if [[ ${PN} != koffice-data ]]; then 556 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
612 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \ 557 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
613 "${S}"/cmake/modules/CMakeLists.txt || \ 558 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
614 die "${LINENO}: sed died in collision prevention section" 559 -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*/if(1) # &/' \
615 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \ 560 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
616 "${S}"/CMakeLists.txt || \ 561 -i CMakeLists.txt || die "failed to disable hardcoded checks"
617 die "${LINENO}: sed died in collision prevention section" 562 # Disable broken or redundant build logic
563 if use_if_iuse kontact || [[ ${PN} = kontact ]]; then
564 sed -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*$/if(1) # &/' \
565 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
566 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
618 fi 567 fi
568 if [[ $(get_kde_version) < 4.5 ]]; then
569 case ${PN} in
570 kalarm|kmailcvt|kontact|korganizer|korn)
571 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
572 -e '/add_custom_target(kmail_xml /,/)/p' \
573 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
574 _change_cmakelists_parent_dirs kmail
575 ;;
576 esac
577 fi
578 ;;
579 kdewebdev)
580 # Disable hardcoded checks
581 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
582 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
583 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
584 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
585 -i CMakeLists.txt || die "failed to disable hardcoded checks"
586 ;;
619 esac 587 esac
620 588
621 popd > /dev/null 589 popd > /dev/null
622} 590}
623 591
626# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 594# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
627# ebuilds. 595# ebuilds.
628kde4-meta_src_configure() { 596kde4-meta_src_configure() {
629 debug-print-function ${FUNCNAME} "$@" 597 debug-print-function ${FUNCNAME} "$@"
630 598
599 # backwards-compatibility: make mycmakeargs an array, if it isn't already
600 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
601 mycmakeargs=(${mycmakeargs})
602 fi
603
631 # Set some cmake default values here (usually workarounds for automagic deps) 604 # Set some cmake default values here (usually workarounds for automagic deps)
632 case ${KMNAME} in 605 case ${KMNAME} in
633 kdewebdev) 606 kdewebdev)
634 mycmakeargs=" 607 mycmakeargs=(
635 -DWITH_KdepimLibs=OFF 608 -DWITH_KdepimLibs=OFF
636 -DWITH_LibXml2=OFF 609 -DWITH_LibXml2=OFF
637 -DWITH_LibXslt=OFF 610 -DWITH_LibXslt=OFF
638 -DWITH_Boost=OFF 611 -DWITH_Boost=OFF
639 -DWITH_LibTidy=OFF 612 -DWITH_LibTidy=OFF
640 ${mycmakeargs}" 613 "${mycmakeargs[@]}"
614 )
641 ;; 615 ;;
642 esac 616 esac
643 617
644 kde4-base_src_configure 618 kde4-base_src_configure
645} 619}
649# General function for compiling split KDE4 applications. 623# General function for compiling split KDE4 applications.
650# Overrides kde4-base_src_compile. 624# Overrides kde4-base_src_compile.
651kde4-meta_src_compile() { 625kde4-meta_src_compile() {
652 debug-print-function ${FUNCNAME} "$@" 626 debug-print-function ${FUNCNAME} "$@"
653 627
654 kde4-base_src_compile 628 kde4-base_src_compile "$@"
655} 629}
656 630
657# @FUNCTION: kde4-meta_src_test 631# @FUNCTION: kde4-meta_src_test
658# @DESCRIPTION: 632# @DESCRIPTION:
659# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 633# Currently just calls its equivalent in kde4-base.eclass(5) if
660# ebuilds. 634# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
661kde4-meta_src_test() { 635kde4-meta_src_test() {
662 debug-print-function $FUNCNAME "$@" 636 debug-print-function $FUNCNAME "$@"
663 637
638 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
664 kde4-base_src_test 639 kde4-base_src_test
640 else
641 einfo "Tests disabled"
642 fi
665} 643}
666 644
667# @FUNCTION: kde4-meta_src_install 645# @FUNCTION: kde4-meta_src_install
668# @DESCRIPTION: 646# @DESCRIPTION:
669# Function for installing KDE4 split applications. 647# Function for installing KDE4 split applications.
670kde4-meta_src_install() { 648kde4-meta_src_install() {
671 debug-print-function $FUNCNAME "$@" 649 debug-print-function $FUNCNAME "$@"
672 650
651 # Search ${S}/${KMMODULE} and install common documentation files found
652 local doc
653 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
654 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
655 done
656
673 kde4-base_src_install 657 kde4-base_src_install
674} 658}
675 659
676# @FUNCTION: kde4-meta_src_make_doc 660# @FUNCTION: kde4-meta_pkg_preinst
677# @DESCRIPTION: 661# @DESCRIPTION:
678# This function searches in ${S}/${KMMODULE}, 662# Invoke its equivalent in kde4-base.eclass.
679# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist. 663kde4-meta_pkg_preinst() {
680kde4-meta_src_make_doc() {
681 debug-print-function ${FUNCNAME} "$@" 664 debug-print-function ${FUNCNAME} "$@"
682 665
683 local doc 666 kde4-base_pkg_preinst
684 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
685 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}"
686 done
687
688 kde4-base_src_make_doc
689} 667}
690 668
691# @FUNCTION: kde4-meta_pkg_postinst 669# @FUNCTION: kde4-meta_pkg_postinst
692# @DESCRIPTION: 670# @DESCRIPTION:
693# Display information about application handbook and invoke kbuildsycoca4. 671# Invoke kbuildsycoca4.
694kde4-meta_pkg_postinst() { 672kde4-meta_pkg_postinst() {
695 debug-print-function ${FUNCNAME} "$@" 673 debug-print-function ${FUNCNAME} "$@"
696
697 if has doc ${IUSE//+} && ! use doc; then
698 echo
699 einfo "Application handbook for ${PN} has not been installed."
700 einfo "To install handbook, reemerge =${CATEGORY}/${P} with 'doc' USE flag."
701 echo
702 fi
703 674
704 kde4-base_pkg_postinst 675 kde4-base_pkg_postinst
705} 676}
706 677
707# @FUNCTION: kde4-meta_pkg_postrm 678# @FUNCTION: kde4-meta_pkg_postrm

Legend:
Removed from v.1.19  
changed lines
  Added in v.1.68

  ViewVC Help
Powered by ViewVC 1.1.20